
/*!
 ***************************************************************************
 * \file
 *    q_matrix.h
 *
 * \brief
 *    Headerfile for q_matrix array
 *
 * \date
 *    07. Apr 2004
 ***************************************************************************
 */

#ifndef _Q_MATRIX_H_
#define _Q_MATRIX_H_

extern int ****LevelScale4x4Luma;
extern int *****LevelScale4x4Chroma;
extern int ****LevelScale8x8Luma;

extern int ****InvLevelScale4x4Luma;
extern int *****InvLevelScale4x4Chroma;
extern int ****InvLevelScale8x8Luma;

extern short ScalingList4x4input[6][16];
extern short ScalingList8x8input[2][64];
extern short ScalingList4x4[6][16];
extern short ScalingList8x8[2][64];

extern short UseDefaultScalingMatrix4x4Flag[6];
extern short UseDefaultScalingMatrix8x8Flag[2];

#ifdef ADAPTIVE_QUANTIZATION
extern int *****LevelScale4x4Luma_IAQMS;        // For I,P,B-slice
extern int ******LevelScale4x4Chroma_IAQMS;     // For I,P,B-slice
extern int *****LevelScale8x8Luma_IAQMS;        // For I,P,B-slice

extern int *****InvLevelScale4x4Luma_IAQMS;     // For I,P,B-slice
extern int ******InvLevelScale4x4Chroma_IAQMS;  // For I,P,B-slice
extern int *****InvLevelScale8x8Luma_IAQMS;     // For I,P,B-slice

extern short ScalingList4x4_IAQMS[NUM_OF_IAQMS_MAT][6][16];
extern short ScalingList8x8_IAQMS[NUM_OF_IAQMS_MAT][2][64];

#ifdef MB32X32
extern short ScalingList16x16[2][256];
extern short ScalingList16x8[2][128];
extern short ScalingList8x16[2][128];

extern int *****LevelScale16x16Luma_IAQMS;
extern int *****LevelScale16x8Luma_IAQMS;
extern int *****LevelScale8x16Luma_IAQMS;
extern int *****InvLevelScale16x16Luma_IAQMS;
extern int *****InvLevelScale16x8Luma_IAQMS;
extern int *****InvLevelScale8x16Luma_IAQMS;
extern short ScalingList16x16_IAQMS[NUM_OF_IAQMS_MAT][2][256];
extern short ScalingList16x8_IAQMS[NUM_OF_IAQMS_MAT][2][128];
extern short ScalingList8x16_IAQMS[NUM_OF_IAQMS_MAT][2][128];
void CalculateQuant16Param(void);
#endif

#ifdef USE_INTRA_MDDT
extern int *****LevelScale4x4Luma_IAQMS_MDDT;
extern int *****LevelScale8x8Luma_IAQMS_MDDT;
extern int *****InvLevelScale4x4Luma_IAQMS_MDDT;
extern int *****InvLevelScale8x8Luma_IAQMS_MDDT;
void CalculateQuantMDDTParam(void);
#endif
#endif



extern int *qp_per_matrix;
extern int *qp_rem_matrix;


void Init_QMatrix (void);
void CalculateQuantParam(void);
void CalculateQuant8Param(void);
void free_QMatrix(void);

#endif
