
#include "defines.h"

int pattern9x9Sym[] = {
    0,  1,  2,  3,  4,  3,  2,  1,  0,
    5,  6,  7,  8,  9,  8,  7,  6,  5,   
    10, 11, 12, 13, 14, 13, 12, 11, 10,
    15, 16, 17, 18, 19, 18, 17, 16, 15,      
    20, 21, 22, 23, 24, 23, 22, 21, 20, 
    15, 16, 17, 18, 19, 18, 17, 16, 15, 
    10, 11, 12, 13, 14, 13, 12, 11, 10,
    5,  6,  7,  8,  9,  8,  7,  6,  5, 
    0,  1,  2,  3,  4,  3,  2,  1,  0
};

int weights9x9Sym[] = {
  4,  4,  4,  4,  2,  
  4,  4,  4,  4,  2,   
  4,  4,  4,  4,  2,  
  4,  4,  4,  4,  2,  
  2,  2,  2,  2,  1, 1
};

int pattern9x9Sym_Quart[] = {
  1,  2,  3,  4,  5,  
  6,  7,  8,  9, 10,  
  11, 12, 13, 14, 15, 
  16, 17, 18, 19, 20, 
  21, 22, 23, 24, 25, 26
};

int pattern7x7Sym[] = {
    0,  1,  2,   3,  2, 1,  0,
    4,  5,  6,   7,  6, 5,  4, 
    8,  9, 10,  11, 10, 9,  8,
    12, 13, 14, 15, 14, 13, 12,
    8,  9, 10,  11, 10, 9,  8,
    4,  5,  6,   7,  6, 5,  4,
    0,  1,  2,   3,  2, 1,  0
};

int weights7x7Sym[] = {
  4,  4,  4,  2,  
  4,  4,  4,  2,   
  4,  4,  4,  2,   
  2,  2,  2,  1, 1
};

int pattern7x7Sym_Quart[] = {
  0,  0,  0,  0,   0,  
  0,  1,  2,  3,   4,  
  0,  5,  6,  7,   8,  
  0,  9, 10, 11,  12, 
  0, 13, 14, 15,  16, 17
};

int pattern5x5Sym[] = {
    0,  1,  2, 1, 0,  
    3,  4,  5, 4, 3,   
    6,  7,  8, 7, 6, 
    3,  4,  5, 4, 3,
    0,  1,  2, 1, 0
};

int weights5x5Sym[] = {
  4,  4,  2,  
  4,  4,  2,   
  2,  2,  1, 1
};

int pattern5x5Sym_Quart[] = {
  0,  0,  0,  0,   0, 
  0,  0,  0,  0,   0,  
  0,  0,  1,  2,   3,  
  0,  0,  4,  5,   6,  
  0,  0,  7,  8,   9, 10
};

extern results psnrBitsRes;


//
//
//
double decFilterVarPred(imgpel **imgY_rec, imgpel **imgY_org, imgpel **varImg, int filtNo_best, double **filterCoeffSym, 
                       int varIndTab[NO_VAR_BINS], int usePrevFiltBest[NO_VAR_BINS], int prevFiltInd, int codedFlag,
                       int img_height, int img_width)
{
  int i, j, ii, jj, k, pixelInt, varInd, temp;
  int vectorInd;
  double  seFilt, pixelDouble;
  static imgpel  **imgY_filt, **imgY_pad;
  static double *filterCoeffDefault, ***filterCoeffPrev, **filterCoeffPrevSelected;
  int fl, sqrFiltLength;
  int *pattern, *patternMap, *patternMapTab[NO_TEST_FILT]={pattern9x9Sym_Quart, pattern7x7Sym_Quart, pattern5x5Sym_Quart};
  static int availableFilters, first=1;
  static int frNoCoded=0;
  static int frNo = 0;

  double errPerVar[NO_VAR_BINS] = {0};

  sqrFiltLength=MAX_SQR_FILT_LENGTH;  fl=FILTER_LENGTH/2;

  if (first==1){

    initMatrix_ushort(&imgY_pad, img_height+2*fl, img_width+2*fl);
    initMatrix_ushort(&imgY_filt, img_height, img_width);
 
    initMatrix3D_double(&filterCoeffPrev, NO_PREV_FILTERS, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 
    initMatrix_double(&filterCoeffPrevSelected, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 

    filterCoeffDefault = (double *) calloc(MAX_SQR_FILT_LENGTH, sizeof(double));
    filterCoeffDefault[MAX_SQR_FILT_LENGTH - 2] = 1;
  }

  padImage(imgY_rec, imgY_pad, fl, img_height, img_width);

  if (first==0){
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      if (usePrevFiltBest[varInd]==1){
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffPrevSelected[varInd][i]=filterCoeffPrev[prevFiltInd][varInd][i];
        }
      }
      else{
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffPrevSelected[varInd][i]=filterCoeffDefault[i];
        }
      }
    }
  }
  else{
    availableFilters=0;
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        filterCoeffPrevSelected[varInd][i]=0;
      }
    }
  }

  if (first==0){
    patternMap=patternMapTab[filtNo_best];
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      k=0;
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        if (patternMap[i]>0){
          filterCoeffPrevSelected[varInd][i]+=filterCoeffSym[varIndTab[varInd]][k];
          k++;
        }
      }
    }
  }
  else{
    patternMap=patternMapTab[filtNo_best];
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      k=0;
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        if (patternMap[i]>0){
          filterCoeffPrevSelected[varInd][i]=filterCoeffSym[varIndTab[varInd]][k];
          k++;
        }
      }
    }
  }

  pattern=pattern9x9Sym;


  // Filter
  seFilt=0; 

  for (i = fl; i < img_height+fl; i++){
    for (j = fl; j < img_width+fl; j++){

      varInd=min(varImg[i-fl][j-fl],NO_VAR_BINS-1);
      pixelDouble=0; k=0;

      for (ii=i-fl; ii<=i+fl; ii++){
        for (jj=j-fl; jj<=j+fl; jj++){  
          vectorInd=pattern[k++];
          pixelDouble+=(imgY_pad[ii][jj]*filterCoeffPrevSelected[varInd][vectorInd]);
        }
      }
      pixelDouble+=filterCoeffPrevSelected[varInd][sqrFiltLength-1];
      pixelInt=(int)floor(pixelDouble+0.5);

      imgY_rec[i-fl][j-fl]=max(0, min(pixelInt,255));
      temp=(imgY_rec[i-fl][j-fl]-imgY_org[i-fl][j-fl]);
      seFilt+=temp*temp;

      errPerVar[varInd] += temp*temp;
    }
  }

  if(codedFlag)
  {
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        filterCoeffPrev[frNoCoded%NO_PREV_FILTERS][varInd][i]=filterCoeffPrevSelected[varInd][i];
      }
    }
    availableFilters++; frNoCoded++;
    availableFilters=min(NO_PREV_FILTERS-1,availableFilters);
  }
  frNo++;
  first=0;

  return(seFilt);
}



