//
//
//
#include "defines.h"

//
//
//
int Clip3Fun(int low, int high, int val)
{
  return ((val < low)? low: (val > high)? high: val);
}

//
//
//
void initImg(imgStruct *imgIn, int height, int width)
{
  initMatrix_ushort(&(imgIn->imgY), height, width);
  initMatrix3D_ushort(&(imgIn->imgUV), 2, height/2, width/2);
  imgIn->img_height = height;
  imgIn->img_width = width;
}

//
//
//
void int2Byte(imgStruct *imgIn, int width, int height) 
{
  int i, j, uv;
  
  for(i=0; i < height; i++)
    for(j=0; j < width; j++)
      imgIn->imgY[i][j] = Clip3Fun(0, 255, imgIn->imgY[i][j]);
  
  for(uv = 0; uv < 2; uv++)
    for(i = 0; i < height/2; i++)
      for(j = 0; j < width/2; j++)
        imgIn->imgUV[uv][i][j] = Clip3Fun(0, 255, imgIn->imgUV[uv][i][j]);
}

//
//
//
void padImage(imgpel **imgY,  imgpel **imgY_pad, int fl, int img_height, int img_width)
{
  int x, y;

  for(y = 0; y < img_height; ++y)
    for(x = 0; x < img_width; ++x)
      imgY_pad[y+fl][x+fl] = imgY[y][x];

  for(x = fl; x < img_width + fl; ++x) 
  {
    for(y = 0; y < fl; ++y)
      imgY_pad[y][x] = imgY_pad[fl][x];

    for(y = img_height + fl; y < img_height + 2 * fl; ++y)
      imgY_pad[y][x] = imgY_pad[img_height + fl - 1][x];
  }

  for(y = 0; y < img_height + 2 * fl; ++y)
  {
    for(x = 0; x < fl; ++x)
      imgY_pad[y][x] = imgY_pad[y][fl];

    for(x = img_width + fl; x < img_width + 2 * fl; ++x)
      imgY_pad[y][x] = imgY_pad[y][img_width + fl - 1];
  }
}

//
//
//
void  calcVar(imgpel **imgY_var, imgpel **imgY_rec, int fl, int img_height, int img_width)
{
  int i, j, ii, jj, noSamples=(2*fl+1)*(2*fl+1);
  int sum;
  static imgpel **imgY_pad;
  static int **imgY_temp, first = 0;

  if(first == 0)
  {
    initMatrix_ushort(&imgY_pad, img_height+2*fl+2, img_width+2*fl+2);
    initMatrix_int(&imgY_temp, img_height+2*fl, img_width+2*fl);
    first=1;
  }

  padImage(imgY_rec, imgY_pad, fl+1, img_height, img_width);

  for(i = 1; i < img_height + 2 * fl + 1; ++i)
    for(j = 1; j < img_width + 2 * fl + 1; ++j)  
      imgY_temp[i-1][j-1] = abs(2 * imgY_pad[i][j] - imgY_pad[i][j+1] - imgY_pad[i][j-1])+
      abs(2 * imgY_pad[i][j] - imgY_pad[i-1][j] - imgY_pad[i+1][j]);

  for(i = fl; i < img_height + fl; ++i)
  {
    for(j = fl; j < img_width + fl; ++j)
    {  
      sum = 0;
      for(ii = i - fl; ii <= i + fl; ii++)
        for(jj = j - fl; jj <= j + fl; jj++)
          sum+=imgY_temp[ii][jj];

#if NO_VAR_BINS == 16
      imgY_var[i - fl][j - fl] = (imgpel) Clip3Fun(0, 255, (int)(sum / (double)(2 * noSamples) + 0.5));
#else
      imgY_var[i - fl][j - fl] = (imgpel) Clip3Fun(0, 255, (int)(sum / (double) noSamples + 0.5));
#endif
    }
  }
}
