
#include "defines.h"

extern int pattern9x9Sym[];
extern int pattern9x9Sym_Quart[];
extern int pattern7x7Sym[];
extern int pattern7x7Sym_Quart[];
extern int pattern5x5Sym[];
extern int pattern5x5Sym_Quart[];

extern results psnrBitsRes;


//
//
//
double decFilterVarPred(imgpel **imgY_rec, imgpel **imgY_org, imgpel **varImg, int filtNo_best, double **filterCoeffSym, 
                       int varIndTab[NO_VAR_BINS], int usePrevFiltBest[NO_VAR_BINS], int prevFiltInd, int codedFlag,
                       int img_height, int img_width)
{
  int i, j, ii, jj, k, pixelInt, varInd, temp;
  int vectorInd;
  double  seFilt, pixelDouble;
  static imgpel  **imgY_filt, **imgY_pad;
  static double *filterCoeffDefault, ***filterCoeffPrev, **filterCoeffPrevSelected;
  int fl, sqrFiltLength;
  int *pattern, *patternMap, *patternMapTab[NO_TEST_FILT]={pattern9x9Sym_Quart, pattern7x7Sym_Quart, pattern5x5Sym_Quart};
  static int availableFilters, first=1;
  static int frNoCoded=0;
  static int frNo = 0;

  double errPerVar[NO_VAR_BINS] = {0};

  sqrFiltLength=MAX_SQR_FILT_LENGTH;  fl=FILTER_LENGTH/2;

  if (first==1){

    initMatrix_ushort(&imgY_pad, img_height+2*fl, img_width+2*fl);
    initMatrix_ushort(&imgY_filt, img_height, img_width);
 
    initMatrix3D_double(&filterCoeffPrev, NO_PREV_FILTERS, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 
    initMatrix_double(&filterCoeffPrevSelected, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 

    filterCoeffDefault = (double *) calloc(MAX_SQR_FILT_LENGTH, sizeof(double));
    filterCoeffDefault[MAX_SQR_FILT_LENGTH - 2] = 1;
  }

  padImage(imgY_rec, imgY_pad, fl, img_height, img_width);

  if (first==0){
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      if (usePrevFiltBest[varInd]==1){
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffPrevSelected[varInd][i]=filterCoeffPrev[prevFiltInd][varInd][i];
        }
      }
      else{
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffPrevSelected[varInd][i]=filterCoeffDefault[i];
        }
      }
    }
  }
  else{
    availableFilters=0;
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        filterCoeffPrevSelected[varInd][i]=0;
      }
    }
  }

  if (first==0){
    patternMap=patternMapTab[filtNo_best];
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      k=0;
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        if (patternMap[i]>0){
          filterCoeffPrevSelected[varInd][i]+=filterCoeffSym[varIndTab[varInd]][k];
          k++;
        }
      }
    }
  }
  else{
    patternMap=patternMapTab[filtNo_best];
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      k=0;
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        if (patternMap[i]>0){
          filterCoeffPrevSelected[varInd][i]=filterCoeffSym[varIndTab[varInd]][k];
          k++;
        }
      }
    }
  }

  pattern=pattern9x9Sym;


  // Filter
  seFilt=0; 

  for (i = fl; i < img_height+fl; i++){
    for (j = fl; j < img_width+fl; j++){

      varInd=min(varImg[i-fl][j-fl],NO_VAR_BINS-1);
      pixelDouble=0; k=0;

      for (ii=i-fl; ii<=i+fl; ii++){
        for (jj=j-fl; jj<=j+fl; jj++){  
          vectorInd=pattern[k++];
          pixelDouble+=(imgY_pad[ii][jj]*filterCoeffPrevSelected[varInd][vectorInd]);
        }
      }
      pixelDouble+=filterCoeffPrevSelected[varInd][sqrFiltLength-1];
      pixelInt=(int)floor(pixelDouble+0.5);

      imgY_rec[i-fl][j-fl]=max(0, min(pixelInt,255));
      temp=(imgY_rec[i-fl][j-fl]-imgY_org[i-fl][j-fl]);
      seFilt+=temp*temp;

      errPerVar[varInd] += temp*temp;
    }
  }

  if(codedFlag){
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        filterCoeffPrev[frNoCoded%NO_PREV_FILTERS][varInd][i]=filterCoeffPrevSelected[varInd][i];
      }
    }
    availableFilters++; frNoCoded++;
    availableFilters=min(NO_PREV_FILTERS-1,availableFilters);
  }
  frNo++;
  first=0;

  return(seFilt);
}

